Bug 1311146 - glfs_dup() functionality is broken
glfs_dup() functionality is broken
Status: CLOSED CURRENTRELEASE
Product: GlusterFS
Classification: Community
Component: libgfapi (Show other bugs)
mainline
All All
low Severity medium
: ---
: ---
Assigned To: rjoseph
Sudhir D
: Tracking, Triaged
Depends On:
Blocks: 1303995 1317863
  Show dependency treegraph
 
Reported: 2016-02-23 08:47 EST by Prashanth Pai
Modified: 2017-03-06 12:39 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 1317863 (view as bug list)
Environment:
Last Closed: 2017-03-06 12:39:26 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Prashanth Pai 2016-02-23 08:47:06 EST
Description of problem:
***********************
glfs_dup() functionality is currently broken in glusterfs.


Steps to Reproduce: 
*******************
Code snippet from libgfapi-python tests:

    f = File(self.vol.open("dune", os.O_CREAT | os.O_EXCL | os.O_RDWR))
    f.write("I must not fear. Fear is the mind-killer.")
    fdup = f.dup()
    self.assertTrue(isinstance(fdup, File))
    f.close()
    ret = fdup.lseek(0, os.SEEK_SET)
    self.assertEqual(ret, 0)


Actual results:
***************
ERROR: test_write_file_dup_lseek_read (test.functional.libgfapi-python-tests.FileOpsTest)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/root/src/libgfapi-python/test/functional/libgfapi-python-tests.py", line 236, in test_write_file_dup_lseek_read
    ret = fdup.lseek(0, os.SEEK_SET)
  File "/root/src/libgfapi-python/gluster/gfapi.py", line 306, in lseek
    raise OSError(err, os.strerror(err))
OSError: [Errno 9] Bad file descriptor


Expected results:
*****************
lseek() should succeed.


Additional information
**********************
This change (http://review.gluster.org/13340) disallows any operation on duplicate once the original fd is closed.

Seems like a deep copy of original fd instance should be done.
Comment 1 Vijay Bellur 2016-03-10 05:14:36 EST
REVIEW: http://review.gluster.org/13666 (gfapi: preserve glfd state during glfs_dup) posted (#1) for review on master by Rajesh Joseph (rjoseph@redhat.com)
Comment 2 rjoseph 2016-03-10 05:59:58 EST
glfs_dup is completely broken. Current behavior is not in accordance with POSIX dup (http://linux.die.net/man/2/dup)

http://review.gluster.org/13666 only addresses are very small subset of the problem. glfs_dup needs to be re-written to fix the broken behavior. Therefore not changing the state of the bug as of now.
Comment 3 Vijay Bellur 2016-03-15 02:46:39 EDT
COMMIT: http://review.gluster.org/13666 committed in master by Niels de Vos (ndevos@redhat.com) 
------
commit 5bdfaf98904a339144bf3a237b162e8385b95085
Author: Rajesh Joseph <rjoseph@redhat.com>
Date:   Wed Mar 9 22:05:18 2016 +0530

    gfapi: preserve glfd state during glfs_dup
    
    Following patch introduced a new state variable in glfd
    to track the current status of the fd.
    http://review.gluster.org/13340/
    
    But this state was not copied in glfd_dup function.
    
    BUG: 1311146
    Change-Id: I283f8944035f6defe491f81e13d7ef28fc440572
    Signed-off-by: Rajesh Joseph <rjoseph@redhat.com>
    Reviewed-on: http://review.gluster.org/13666
    Smoke: Gluster Build System <jenkins@build.gluster.com>
    Reviewed-by: Prashanth Pai <ppai@redhat.com>
    Tested-by: Prashanth Pai <ppai@redhat.com>
    NetBSD-regression: NetBSD Build System <jenkins@build.gluster.org>
    CentOS-regression: Gluster Build System <jenkins@build.gluster.com>
    Reviewed-by: Raghavendra Talur <rtalur@redhat.com>
    Reviewed-by: Niels de Vos <ndevos@redhat.com>

Note You need to log in before you can comment on or make changes to this bug.